Bug 872020 - Review Request: ocaml-tplib - Tropical Polyhedra Library
Review Request: ocaml-tplib - Tropical Polyhedra Library
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Paulo Andrade
Fedora Extras Quality Assurance
:
Depends On: 870522
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-31 22:36 EDT by Jerry James
Modified: 2013-01-28 10:20 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-28 10:20:35 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
paulo.cesar.pereira.de.andrade: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jerry James 2012-10-31 22:36:08 EDT
Spec URL: http://jjames.fedorapeople.org/ocaml-tplib/ocaml-tplib.spec
SRPM URL: http://jjames.fedorapeople.org/ocaml-tplib/ocaml-tplib-1.2-1.fc19.src.rpm
Description: TPLib computes a description by means of vertices and rays of tropical polyhedra defined by means of inequalities, and conversely.

It also provides a numerical abstract domain based on tropical polyhedra, in order to infer min-/max- invariants over programs.
Fedora Account System Username: jjames
Comment 1 Paulo Andrade 2013-01-15 12:05:23 EST
I will review this package, for a review swap with #894610
Comment 2 Paulo Andrade 2013-01-15 21:42:38 EST
This one also have spec and spec from srpm not matching, so I assume
the spec to use is the one in the srpm.

I am not familiar with ocaml, so please describe me how it works,
and that it is correct:
RPMS/x86_64/ocaml-tplib-1.2-1.fc19.x86_64.rpm:
mlgmpidl_plugin.cmxs()(64bit)
ocaml(Halfspace) = 9ea926c8cef685f376a6b194fcc14444
[...]
Should it really provide mlgmpidl_plugin.cmxs? I presume the others
are ok, but does ocaml understand that it must search whatever
ocaml(Halfspace) in %{_libdir}/ocaml/tplib? I mean, how it
knows about the tplib subdir? Is it automatically added to some
kind of search path, or maybe it does a deep search in the
base directory? Same questions about mlgmpidl_plugin.cmxs.

The error about static libraries probably should be addressed,
unless there is some good reason not to, that is, the -devel
package should also have a:
Provides: %{name}-static
I believe there is already a good explanation about the
static libraries under %{_libdir}/ocaml :-)

Generating manpages for the binaries probably is optional, but
should not be too hard to, just that needs some manual parsing
of help2man output as well as its arguments (e.g. tell to not
create a look at info page and pass version as argument to
help2man).

---%<---

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Static libraries in -static subpackage, if present.
     Note: ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/libtplib_double.a ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/libtplib_rational.a ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/ocaml/tplib/tplib.a
See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries


===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[!]: Static libraries in -static subpackage, if present.
     Note: ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/libtplib_double.a ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/libtplib_rational.a ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm :
     /usr/lib64/ocaml/tplib/tplib.a

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in %package
     devel, %package tools
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2.1 or later)", "Unknown or generated". 2 files have unknown
     license. Detailed output of licensecheck in /home/pcpa/872020-ocaml-
     tplib/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[?]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (TPLib-1.2.tar.gz)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: ocaml-tplib-tools-1.2-1.fc19.x86_64.rpm
          ocaml-tplib-1.2-1.fc19.x86_64.rpm
          ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm
          ocaml-tplib-1.2-1.fc19.src.rpm
ocaml-tplib-tools.x86_64: W: no-documentation
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_tangent_hypergraph
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_halfspaces
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_ext_rays_polar
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_ext_rays
ocaml-tplib.x86_64: W: spelling-error %description -l en_US vertices -> cervices
ocaml-tplib.x86_64: W: spelling-error %description -l en_US polyhedra -> polyhedral, polyhedron
ocaml-tplib.x86_64: W: spelling-error %description -l en_US invariants -> invariant, in variants, in-variants
ocaml-tplib-devel.x86_64: W: no-documentation
ocaml-tplib.src: W: spelling-error %description -l en_US vertices -> cervices
ocaml-tplib.src: W: spelling-error %description -l en_US polyhedra -> polyhedral, polyhedron
ocaml-tplib.src: W: spelling-error %description -l en_US invariants -> invariant, in variants, in-variants
4 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ocaml-tplib-tools ocaml-tplib-devel ocaml-tplib
ocaml-tplib-tools.x86_64: W: no-documentation
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_tangent_hypergraph
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_halfspaces
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_ext_rays_polar
ocaml-tplib-tools.x86_64: W: no-manual-page-for-binary compute_ext_rays
ocaml-tplib-devel.x86_64: W: no-documentation
ocaml-tplib.x86_64: W: spelling-error %description -l en_US polyhedra -> polyhedral, polyhedron
ocaml-tplib.x86_64: W: spelling-error %description -l en_US invariants -> invariant, in variants, in-variants
3 packages and 0 specfiles checked; 0 errors, 8 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/pcpa/872020-ocaml-tplib/srpm/ocaml-tplib.spec	2013-01-16 00:05:25.657061964 -0200
+++ /home/pcpa/872020-ocaml-tplib/srpm-unpacked/ocaml-tplib.spec	2013-01-16 00:05:29.279062042 -0200
@@ -64,5 +64,5 @@
 make install bindir=%{buildroot}%{_bindir} libdir=%{buildroot}%{_libdir} \
   includedir=%{buildroot}%{_includedir}
-mv %{buildroot}%{_libdir}/*.a %{buildroot}%{_libdir}/ocaml/tplib
+
 strip %{buildroot}%{_bindir}/compute*
 strip %{buildroot}%{_libdir}/ocaml/tplib/*.cmxs
@@ -82,4 +82,5 @@
 %files devel
 %{_includedir}/tplib_*.h
+%{_libdir}/*.a
 %{_libdir}/ocaml/tplib/*.a
 %{_libdir}/ocaml/tplib/*.cmxa


Requires
--------
ocaml-tplib-tools-1.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libc.so.6()(64bit)  
    libdl.so.2()(64bit)  
    libm.so.6()(64bit)  
    ocaml-tplib(x86-64) = 1.2-1.fc19
    rtld(GNU_HASH)  

ocaml-tplib-1.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libc.so.6()(64bit)  
    libgmp.so.10()(64bit)  
    libmpfr.so.4()(64bit)  
    ocaml(Buffer) = 3f6c994721573c9f8b5411e6824249f4
    ocaml(Format) = 6e6b7b75c544ef4ca673a763aec805af
    ocaml(Hypergraph) = d7bf6cba57aa76ccb1ab699780296351
    ocaml(Numeric) = 5f141b41401051228ac651fb89ef6c8f
    ocaml(Pervasives) = 4836c254f0eacad92fbf67abc525fdda
    ocaml(Semiring) = 77ffc91ae18d4477af8154531a3c1450
    ocaml(Vector) = c71b27848af62f48f3c59aa2158f2dad
    ocaml(runtime) = 4.00.1
    rtld(GNU_HASH)  

ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    ocaml-tplib(x86-64) = 1.2-1.fc19



Provides
--------
ocaml-tplib-tools-1.2-1.fc19.x86_64.rpm:
    
    ocaml-tplib-tools = 1.2-1.fc19
    ocaml-tplib-tools(x86-64) = 1.2-1.fc19

ocaml-tplib-1.2-1.fc19.x86_64.rpm:
    
    mlgmpidl_plugin.cmxs()(64bit)  
    ocaml(Halfspace) = 9ea926c8cef685f376a6b194fcc14444
    ocaml(Hypergraph) = d7bf6cba57aa76ccb1ab699780296351
    ocaml(Numeric) = 5f141b41401051228ac651fb89ef6c8f
    ocaml(Semiring) = 77ffc91ae18d4477af8154531a3c1450
    ocaml(Tplib_abstract) = 7115d5a79bc0af6fc587c4ef5f58741f
    ocaml(Tplib_core) = 84885330e0a693eed19dc6ed5a04a697
    ocaml(Vector) = c71b27848af62f48f3c59aa2158f2dad
    ocaml-tplib = 1.2-1.fc19
    ocaml-tplib(x86-64) = 1.2-1.fc19
    zarith_plugin.cmxs()(64bit)  

ocaml-tplib-devel-1.2-1.fc19.x86_64.rpm:
    
    ocaml-tplib-devel = 1.2-1.fc19
    ocaml-tplib-devel(x86-64) = 1.2-1.fc19



MD5-sum check
-------------
https://gforge.inria.fr/frs/download.php/30827/TPLib-1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 2729870b00e651a9682f8ea4c1577c40868a1ffa1ca3cd466918c9bc33721ee4
  CHECKSUM(SHA256) upstream package : 2729870b00e651a9682f8ea4c1577c40868a1ffa1ca3cd466918c9bc33721ee4


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 872020 -m fedora-rawhide-x86_64
---%<---
Comment 3 Jerry James 2013-01-16 14:18:31 EST
(In reply to comment #2)
> This one also have spec and spec from srpm not matching, so I assume
> the spec to use is the one in the srpm.

Oops.  How did I do that?!  You used the correct one.

> I am not familiar with ocaml, so please describe me how it works,
> and that it is correct:
> RPMS/x86_64/ocaml-tplib-1.2-1.fc19.x86_64.rpm:
> mlgmpidl_plugin.cmxs()(64bit)
> ocaml(Halfspace) = 9ea926c8cef685f376a6b194fcc14444
> [...]
> Should it really provide mlgmpidl_plugin.cmxs? I presume the others
> are ok, but does ocaml understand that it must search whatever
> ocaml(Halfspace) in %{_libdir}/ocaml/tplib? I mean, how it
> knows about the tplib subdir? Is it automatically added to some
> kind of search path, or maybe it does a deep search in the
> base directory? Same questions about mlgmpidl_plugin.cmxs.

No, there is nothing automatic here.  Users of this library will have to invoke the ocaml compiler with "-I +tplib".  The plugins should not be provided; good catch.  Those are for internal use only.  I have filtered them out.

> The error about static libraries probably should be addressed,
> unless there is some good reason not to, that is, the -devel
> package should also have a:
> Provides: %{name}-static

Done.

> Generating manpages for the binaries probably is optional, but
> should not be too hard to, just that needs some manual parsing
> of help2man output as well as its arguments (e.g. tell to not
> create a look at info page and pass version as argument to
> help2man).

Done.  New URLs:

Spec URL: http://jjames.fedorapeople.org/ocaml-tplib/ocaml-tplib.spec
SRPM URL: http://jjames.fedorapeople.org/ocaml-tplib/ocaml-tplib-1.2-2.fc19.src.rpm
Comment 4 Paulo Andrade 2013-01-16 15:40:58 EST
(In reply to comment #3)

> > Should it really provide mlgmpidl_plugin.cmxs? I presume the others
> > are ok, but does ocaml understand that it must search whatever
> > ocaml(Halfspace) in %{_libdir}/ocaml/tplib? I mean, how it
> > knows about the tplib subdir? Is it automatically added to some
> > kind of search path, or maybe it does a deep search in the
> > base directory? Same questions about mlgmpidl_plugin.cmxs.
> 
> No, there is nothing automatic here.  Users of this library will have to
> invoke the ocaml compiler with "-I +tplib".  The plugins should not be
> provided; good catch.  Those are for internal use only.  I have filtered
> them out.

  Ok. I was checking a few other ocaml-* packages, and they appear to
provide .cmxs files, as well as files under %{_libdir}/ocaml/something/name.cmi
as ocaml(Name). I asked because this looks like a recipe for conflicts as
in the case of:

ocaml-foo with %{_libdir}/ocaml/foo/baz.cmi -> ocaml(Baz)
ocaml-bar with %{_libdir}/ocaml/bar/baz.cmi -> ocaml(Baz)

   Please just confirm that this is correct:
$ rpm -ql ocaml-tplib|grep -i vector
/usr/lib64/ocaml/tplib/vector.cmi
$ rpm -q --provides ocaml-tplib|grep -i vector
ocaml(Vector) = c71b27848af62f48f3c59aa2158f2dad
Comment 5 Jerry James 2013-01-16 16:24:49 EST
Yes, I believe you are right.  This is a recipe for conflicts.  That worries me a great deal.  Nevertheless, I have no control over how those Provides are generated.  They are made by /usr/lib/rpm/ocaml-find-provides.sh.  So, yes, those Provides are correct.
Comment 6 Paulo Andrade 2013-01-16 16:36:24 EST
Ok. Since the provides issue is not specific to this package,
I do not see any remaining problems. I consider the package
APPROVED.
Comment 7 Jerry James 2013-01-16 17:59:15 EST
New Package SCM Request
=======================
Package Name: ocaml-tplib
Short Description: Tropical Polyhedra Library
Owners: jjames
Branches: f18
InitialCC:
Comment 8 Gwyn Ciesla 2013-01-17 07:02:40 EST
Git done (by process-git-requests).
Comment 9 Fedora Update System 2013-01-17 10:52:31 EST
ocaml-tplib-1.2-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ocaml-tplib-1.2-2.fc18
Comment 10 Fedora Update System 2013-01-19 21:59:14 EST
ocaml-tplib-1.2-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 11 Fedora Update System 2013-01-28 10:20:37 EST
ocaml-tplib-1.2-2.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.